package com.loganmagnan.nicknamesplus.commands;

import com.loganmagnan.nicknamesplus.chatcolor.ColorSet;
import com.loganmagnan.nicknamesplus.chatcolor.GradientColor;
import com.loganmagnan.nicknamesplus.playerdata.PlayerData;
import com.loganmagnan.nicknamesplus.utils.ColorUtils;
import com.loganmagnan.nicknamesplus.utils.Utils;
import com.loganmagnan.nicknamesplus.utils.command.BaseCommand;
import com.loganmagnan.nicknamesplus.utils.command.Command;
import com.loganmagnan.nicknamesplus.utils.command.CommandArguments;
import net.md_5.bungee.api.ChatColor;
import org.bukkit.NamespacedKey;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.persistence.PersistentDataType;

import java.util.*;

public class RGBNickCommand extends BaseCommand {

    private com.loganmagnan.nicknamesplus.NicknamesPlus main = com.loganmagnan.nicknamesplus.NicknamesPlus.getInstance();

    @Command(name = "rgbnick", permission = "nicknamesplus.command.rgbnick", usage = "&cUsage: /rgbnick <hex> <hex>")
    @Override
    public void executeAs(CommandArguments command) {
        Player player = command.getPlayer();

        String[] args = command.getArgs();

        CommandSender commandSender = command.getSender();

        if (!(commandSender instanceof Player)) {
            return;
        }

        PlayerData playerData = this.main.getPlayerDataManager().getPlayerData(player.getUniqueId());

        if (args.length == 0) {
            player.sendMessage(ColorUtils.getMessageType(command.getCommand().getUsage()));
        } else if (args.length >= 2) {
            String colorCodeOne = args[0];

            ColorSet<Integer, Integer, Integer> colorSetOne = null;
            ColorSet<Integer, Integer, Integer> colorSetTwo = null;

            if (colorCodeOne.contains("&")) {
                if (!ColorUtils.lookAtColorCode(colorCodeOne)) {
                    ColorUtils.getMessageType(this.main.getMessagesConfig().getConfig().getString("COMMANDS.RGB-NICK.VALID-CHAT-COLOR-CODE"));

                    return;
                }

                ChatColor chatColor = ColorUtils.getColor(colorCodeOne);

                colorSetOne = new ColorSet<>(chatColor.getColor().getRed(), chatColor.getColor().getGreen(), chatColor.getColor().getBlue());
            } else if (colorCodeOne.contains("#")) {
                if (!ColorUtils.isValidHexColorCode(colorCodeOne) || colorCodeOne.length() != 7) {
                    ColorUtils.getMessageType(this.main.getMessagesConfig().getConfig().getString("COMMANDS.RGB-NICK.VALID-HEX-COLOR-CODE"));

                    return;
                }

                colorSetOne = ColorUtils.copyColorSet(colorCodeOne);
            } else {
                ColorUtils.getMessageType(this.main.getMessagesConfig().getConfig().getString("COMMANDS.RGB-NICK.VALID-COLOR-CODE"));

                return;
            }

            String colorCodeTwo = args[1];

            if (colorCodeTwo.contains("&")) {
                if (!ColorUtils.lookAtColorCode(colorCodeTwo)) {
                    ColorUtils.getMessageType(this.main.getMessagesConfig().getConfig().getString("COMMANDS.RGB-NICK.VALID-CHAT-COLOR-CODE"));

                    return;
                }

                ChatColor chatColor = ColorUtils.getColor(colorCodeTwo);

                colorSetTwo = new ColorSet<>(chatColor.getColor().getRed(), chatColor.getColor().getGreen(), chatColor.getColor().getBlue());
            } else if (colorCodeTwo.contains("#") || colorCodeTwo.length() != 7) {
                if (!ColorUtils.isValidHexColorCode(colorCodeTwo)) {
                    ColorUtils.getMessageType(this.main.getMessagesConfig().getConfig().getString("COMMANDS.RGB-NICK.VALID-HEX-COLOR-CODE"));

                    return;
                }

                colorSetTwo = ColorUtils.copyColorSet(colorCodeTwo);
            } else {
                ColorUtils.getMessageType(this.main.getMessagesConfig().getConfig().getString("COMMANDS.RGB-NICK.VALID-COLOR-CODE"));

                return;
            }

            GradientColor gradientColor = new GradientColor(colorSetOne, colorSetTwo);

            playerData.setGradientColor(gradientColor);

            ColorSet<Integer, Integer, Integer> colorSetOneTemporary = new ColorSet<>(playerData.getGradientColor().getColorCodeOne().getRed(), playerData.getGradientColor().getColorCodeOne().getGreen(), playerData.getGradientColor().getColorCodeOne().getBlue());
            ColorSet<Integer, Integer, Integer> colorSetTwoTemporary = new ColorSet<>(playerData.getGradientColor().getColorCodeTwo().getRed(), playerData.getGradientColor().getColorCodeTwo().getGreen(), playerData.getGradientColor().getColorCodeTwo().getBlue());

            List<String> colorCodes = new ArrayList<String>(ColorUtils.getColorCodes(player.getName(), colorSetOneTemporary, colorSetTwoTemporary));

            playerData.setDisplayName(ColorUtils.getMessageType(Utils.getGradientString(player.getName(), "", colorCodes)));

            player.getPersistentDataContainer().set(new NamespacedKey(this.main, "Nickname"), PersistentDataType.STRING, ColorUtils.getMessageType(Utils.getGradientString(player.getName(), "", colorCodes)));

            player.setDisplayName(ColorUtils.getMessageType(Utils.getGradientString(player.getName(), "", colorCodes)));
            player.sendMessage(ColorUtils.getMessageType(this.main.getMessagesConfig().getConfig().getString("COMMANDS.RGB-NICK.RGB-NICKNAME-SET-TO").replace("%rgb-nickname%", Utils.getGradientString(player.getName(),"", colorCodes))));
        }
    }
}