package com.loganmagnan.nicknamesplus.managers;

import com.loganmagnan.nicknamesplus.NicknamesPlus;
import com.loganmagnan.nicknamesplus.chatcolor.ColorSet;
import com.loganmagnan.nicknamesplus.chatcolor.GradientColor;
import com.loganmagnan.nicknamesplus.playerdata.PlayerData;
import lombok.Getter;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

public class PlayerDataManager {

	private NicknamesPlus main = NicknamesPlus.getInstance();

	@Getter private Map<UUID, PlayerData> players = new HashMap<>();

	public PlayerData getOrCreate(UUID uniqueId) {
		return this.players.computeIfAbsent(uniqueId, PlayerData::new);
	}

	public PlayerData getPlayerData(UUID uniqueId) {
		return this.players.getOrDefault(uniqueId, new PlayerData(uniqueId));
	}

	public Collection<PlayerData> getAllPlayers() {
		return this.players.values();
	}

	public void loadPlayerData(PlayerData playerData) {
		playerData.setLoaded(true);
	}

	public void savePlayerData(PlayerData playerData) {

	}

	public void deletePlayer(UUID uniqueId) {
		this.main.getServer().getScheduler().runTaskAsynchronously(this.main, () -> {
			this.savePlayerData(this.players.get(uniqueId));
			this.players.remove(uniqueId);
		});
	}
}
