package com.loganmagnan.nicknamesplus.placeholderapi;

import com.loganmagnan.nicknamesplus.NicknamesPlus;
import com.loganmagnan.nicknamesplus.utils.ColorUtils;
import me.clip.placeholderapi.expansion.PlaceholderExpansion;
import org.bukkit.NamespacedKey;
import org.bukkit.entity.Player;
import org.bukkit.persistence.PersistentDataType;

public class PlaceholderAPIProvider extends PlaceholderExpansion {

    final private NicknamesPlus plugin;

    public PlaceholderAPIProvider(NicknamesPlus plugin) {
        this.plugin = plugin;
    }

    @Override
    public String getIdentifier() {
        return this.plugin.getDescription().getName().toLowerCase();
    }

    @Override
    public String getAuthor() {
        return this.plugin.getDescription().getAuthors().get(0);
    }

    @Override
    public String getVersion() {
        return this.plugin.getDescription().getVersion();
    }

    @Override
    public boolean persist() {
        return true;
    }

    @Override
    public String onPlaceholderRequest(Player player, String identifier) {
        switch (identifier.toLowerCase()) {
            case "playerName":
                if (player.getPersistentDataContainer().get(new NamespacedKey(this.plugin, "Nickname"), PersistentDataType.STRING) == null) {
                    return ColorUtils.getMessageType("&f" + player.getName());
                } else {
                    String displayName = player.getPersistentDataContainer().get(new NamespacedKey(this.plugin, "Nickname"), PersistentDataType.STRING) + "&r";

                    return displayName;
                }
        }

        if (player.getPersistentDataContainer().get(new NamespacedKey(this.plugin, "Nickname"), PersistentDataType.STRING) == null) {
            return ColorUtils.getMessageType("&f" + player.getName());
        } else {
            String displayName = player.getPersistentDataContainer().get(new NamespacedKey(this.plugin, "Nickname"), PersistentDataType.STRING) + "&r";

            return displayName;
        }
    }
}
